/*
FILE
	$Id: bind.c,v 1.70 2003/12/22 16:27:39 ggw Exp $
	bind.c
	Part of mysqlBind.cgi project
AUTHOR
	(C) Gary Wallis 2001, 2002, 2003.
PURPOSE
	GUI independent code:
	1-. Load old msql bind table into this mysql system
	2-. Create named configuration and zone data files
WORKINPROGRESS
	Search for TODO
	clock+60 stuff why?
	New arpa zone: Problems? Check.
	ProcessExtJobQueue: Read mysqlISP job queue and create local job queue
	entries.

	Creation of zone files: Records in what order when? how?

	See TODO
*/

#include "mysqlrad.h"


void PassDirectHtml(char *file);
int SubmitJob(char *cCommand, unsigned uNameServer, char *cZone,
		unsigned uPriority, unsigned uTime);

#ifdef MSQL_PORT
	#include <msql.h>

	char dbip[100]={""};
	char dbname[100]={"mysqlbind"};
	char sourceip[16]={"wsxedc"};//passwd change asap

	int msqlConnectDb(void);
	static int msqlsock=0;
	static char dbip_msql[100]={"207.231.72.34"};
	static char dbname_msql[100]={"ism"};

	void LoadFromISM2(unsigned uNameServer,char *cHostmaster);
	void PrintNSList(FILE *zfp,char *cuNameServer);
	void PrintMXList(FILE *zfp,char *cuMailServers);
#endif


typedef struct {
	unsigned uSerial;
	unsigned uTTL;
	unsigned uRefresh;
	unsigned uRetry;
	unsigned uExp;
	unsigned uNegTTL;
	char cHostmaster[100];
	char cNameServer[100];
} structSOA;

void Import(void);
void ProcessRRLine(char *cLine, char *cZoneName, unsigned uZone, unsigned uCustId, unsigned uNameServer);

structSOA *ProcessSOA(FILE *fp);

void CreateMasterFiles(char *cMasterNS, char *cZone, unsigned uModDBFiles, 
		unsigned uModStubs);
void CreateSlaveFiles(char *cSlaveNS, char *cZone, char *cMasterIP);
void InstallNamedFiles(char *cIpNum);
void SerialNum(char *serial);
void ExportTable(char *cTable, char *cFile);
void SlaveJobQueue(char *cNameServer, char *cMasterIP);
void MasterJobQueue(char *cNameServer);
int ProcessMasterJob(char *cZone,unsigned uDelete,unsigned uModify,unsigned uNew, unsigned uDeleteFirst, char *cMasterNS);
int ProcessSlaveJob(char *cZone,unsigned uDelete,unsigned uModify,unsigned uNew, unsigned uDeleteFirst, char *cMasterNS, char *cMasterIP);
void ConnectMysqlServer(void);
void GenerateArpaZones(void);
int PopulateArpaZone(char *cZone, char *cIPNum, unsigned uHtmlMode,
					unsigned uFromZone);
void GetConfiguration(const char *cName, char *cValue, unsigned uHtml);

//Extern
int AddNewArpaZone(char *cArpaZone, unsigned uExtNameServer, char *cExtHostmaster);
int AddPTRResource(unsigned d, char *cDomain, unsigned uZone);//tresourcefunc.h
void Status(char *cTarget);
char *cGetMainAddress(char *cNameServer);
void UpdateSerialNum(unsigned uZone);

static unsigned uReconfig=0;
static unsigned uReload=0;


//Ext job queue stuff
typedef struct {

	char cZone[100];
	char cMainAddress[16];
	char cTarget[100];
	char cParkedDomains[256];
	char cNameServer[100];
	char cMailServer[100];
	char cMX1[100];
	char cMX2[100];
	char cHostmaster[100];
	unsigned uRevDns;
	unsigned uExpire;
	unsigned uRefresh;
	unsigned uTTL;
	unsigned uRetry;
	unsigned uZoneTTL;
	unsigned uMailServer;
	unsigned uNameServer;

	//Input markers
	unsigned uParamZone;
	unsigned uParamMainAddress;
	unsigned uParamTarget;
	unsigned uParamParkedDomains;
	unsigned uParamNameServer;
	unsigned uParamMailServer;
	unsigned uParamRevDns;
	unsigned uParamMX1;
	unsigned uParamMX2;

} structExtJobParameters;

int SubmitISPJob(char *cJobName,char *cJobData,char *cServer,unsigned uJobDate);
int InformExtJob(char *cRemoteMsg,char *cServer,unsigned uJob,unsigned uJobStatus);
void InitializeParams(structExtJobParameters *structExtParam);
void ParseExtParams(structExtJobParameters *structExtParam, char *cJobData);

MYSQL mysqlext;
void ExtConnectDb(unsigned uHtml);
void ProcessExtJobQueue(char *cServer);
unsigned WebNew(structExtJobParameters *structExtParam,unsigned uJob, char *cServer);
unsigned WebMod(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uJob, char *cServer);
unsigned ModZone(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uExtJob, char *cServer);
unsigned CancelZone(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uJob, char *cServer);
int SubmitSingleExtJob(char *cCommand,char *cZoneArg, unsigned uNameServerArg,
		char *cTargetServer, unsigned uPriorityArg, unsigned uTimeArg
	       			,unsigned *uMasterJob,unsigned uExtJob);
int SubmitExtJob(char *cCommand, unsigned uNameServerArg, char *cZoneArg,
			unsigned uPriorityArg, unsigned uTimeArg, unsigned uExtJob);

unsigned NewSimpleZone(structExtJobParameters *structExtParam,unsigned uJob, char *cServer);
unsigned NewSimpleWebZone(structExtJobParameters *structExtParam,unsigned uJob, char *cServer);

//mysqlISP constants
//tJob.uJobStatus
#define mysqlISP_RemotelyQueued 7
#define mysqlISP_Waiting 10
//tInstance.uStatus:
#define mysqlISP_Deployed 4
#define mysqlISP_Canceled 5
#define mysqlISP_OnHold 6
//

#ifdef MSQL_PORT
void LoadFromISM2(unsigned uNameServer,char *cHostmaster)
{
	m_result *res;
	m_row field;
	register int i;
	time_t clock;
	unsigned uCustId=0;
	unsigned uZone=0;
	unsigned uMailServer;
	char cList[256]={""};
	
	time(&clock);
	
	msqlsock=msqlConnectDb();
	
	sprintf(query,"SELECT * FROM bind");
	i=msqlQuery(msqlsock,query);
	if(msqlErrMsg[0]) mysqlBind(msqlErrMsg);

	Header_ism3("LoadFromISM2()",0);
	printf("</center><font size=2><pre>\n");
	if(i)
	{
	res=msqlStoreResult();
	while((field=msqlFetchRow(res)))
	{
		sscanf(field[7],"%u",&uCustId);
		printf("%s: %s\nMX %s %s\nSN:%s Service:%s Custid:%s Status:%s\n%s\n\n",
				field[0],//zone
				field[1],//addr
				field[2],//mx1
				field[3],//mx2
				field[5],//serial
				field[6],//service= rev dns no/yes
				field[7],//custid
				field[8],//status= active etc.
				field[4]);//other


		//MX Shit...customized for aNet....change for you
		uMailServer=1;
		cList[0]=0;
		if(field[2][0] && field[3][0])
			sprintf(cList,"%.99s\n%.99s\n",FQDomainName(field[2]),
						FQDomainName(field[3]));
		else if(field[2][0])
			sprintf(cList,"%.99s\n",FQDomainName(field[2]));
		else if(field[3][0])
			sprintf(cList,"%.99s\n",FQDomainName(field[3]));

		if(cList[0])
		{
			if(!strncmp(field[2],"mail.anet.net",13) && 
				!strncmp(field[3],"mail2.anet.net",14)) goto LEAVE;

			if(!strncmp(field[2],"mail.artnet.net",15) && 
				!strncmp(field[3],"mail2.artnet.net",16)) goto LEAVE;

			if(!strncmp(field[2],"mail.anet.net",13) && 
				!strncmp(field[3],"mail2.artnet.net",16)) goto LEAVE;

			if(!strncmp(field[2],"mail.artnet.net",15) && 
				!strncmp(field[3],"mail2.anet.net",14)) goto LEAVE;

			if(!strncmp(field[2],"mail.anet.net",13) && !field[3][0]) goto LEAVE;

			if(!strncmp(field[2],"mail.artnet.net",15) && !field[3][0]) goto LEAVE;


			sprintf(query,"INSERT INTO tMailServer SET  cLabel='%s IMPORT',cList='%s',uOwner=%u,uCreatedBy=1, uCreatedDate=%lu"
					,FQDomainName(field[0])
					,cList
					,uCustId
					,clock);

			mysql_query(&mysql,query);
			if(mysql_errno(&mysql)) 
			{
				printf("<font color=yellow>%s</font>\n",
					mysql_error(&mysql));
				continue;
			}
			uMailServer=mysql_insert_id(&mysql);
LEAVE:
		}


		//Zone

//Default TTLs ok?
sprintf(query,"INSERT INTO tZone SET  uZone=0, cZone='%s', uNameServer=%u, uSerial=%s, uExpire=604800, uRefresh=28800, uTTL=86400, uRetry=7200, uZoneTTL=86400, uMailServers=%u, cMainAddress='%s', uOwner=%u, uCreatedBy=1, uCreatedDate=%lu, uModBy=0, uModDate=0, cHostmaster='%s IMPORTED'"
			,FQDomainName(field[0])
			,uNameServer
			,field[5]
			,uMailServer
			,IPNumber(field[1])
			,uCustId
			,clock
			,cHostmaster);

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) 
		{
			printf("<font color=yellow>%s</font>\n",
					mysql_error(&mysql));
			continue;
		}
		uZone=mysql_insert_id(&mysql);

		if(field[4][0])
		{
			char line[1024]={""};
			unsigned start=0;

			for(i=0;i<strlen(field[4])+1;i++)
			{
				//Remove nasty ctrl-m's
				//if(field[4][i]=='\r') continue;

				if(field[4][i]=='\n' || !field[4][i]
						|| field[4][i]=='\r')
				{
					line[start]=0;
					ProcessRRLine(line,field[0],
							uZone,uCustId,0);
					start=0;
				}
				else
				{
					line[start++]=field[4][i];
					if (start>1023) break;
				}
			}
			printf("\n");
		}
	}
	}
	Footer_ism3();

}//LoadFromISM2()


int msqlConnectDb(void)
{
	
	if(!msqlsock)
	{
		if(dbip_msql[0])
			msqlsock=msqlConnect(dbip_msql);
		else
			msqlsock=msqlConnect(NULL);
	
		if(!msqlsock) mysqlBind("Error: msql Database Down");
	}
	else
	{
		return msqlsock;
	}

	msqlSelectDB(msqlsock,dbname_msql);
	if(msqlErrMsg[0])
	{
		mysqlBind(msqlErrMsg);
	}

	return msqlsock;
						
}//end of msqlConnectDb()

#endif

void ProcessRRLine(char *cLine, char *cZoneName, unsigned uZone, 
		unsigned uCustId, unsigned uNameServer)
{
	char cName[100]={""};
	char cParam1[100]={""};
	char cParam2[100]={""};
	char cParam3[100]={""};
	char cParam4[100]={""};
	char cType[100]={""};
	unsigned uRRType=0;
	unsigned uTTL=0;
	time_t clock;

	

	//debug only
	printf("<u>%s</u>\n",cLine);

	if(cLine[0]=='\t')
	{
		sscanf(cLine,"%100s %100s %100s %100s %100s\n",
			cType,cParam1,cParam2,cParam3,cParam4);
		strcpy(cName,"\t");
	}
	else
	{
		sscanf(cLine,"%100s %100s %100s %100s %100s %100s\n",
			cName,cType,cParam1,cParam2,cParam3,cParam4);
	}

	if(!cLine[0] || cLine[0]==';') return;


	//Shift left on TTL
	sscanf(cType,"%u",&uTTL);
	if(uTTL>1 && uTTL<800000)
	{
		strcpy(cType,cParam1);
		strcpy(cParam1,cParam2);
		strcpy(cParam2,cParam3);
		strcpy(cParam3,cParam4);
	}
	
	//Shift left on IN
	if(!strcasecmp(cType,"IN"))
	{
		strcpy(cType,cParam1);
		strcpy(cParam1,cParam2);
		strcpy(cParam2,cParam3);
		strcpy(cParam3,cParam4);
	}


	//Check for recognized data and verify needed params
	if(!strcasecmp(cType,"A"))
	{
		uRRType=1;
		if(!cParam1[0] || cParam2[0])
		{
			printf("<font color=yellow>Incorrect A format: %s</font>\n",cLine);
			return;
		}
		if(!strcmp(IPNumber(cParam1),"0.0.0.0"))
		{
			printf("<font color=yellow>Incorrect A IP number format: %s</font>\n",cLine);
			return;
		}
	}
	else if(!strcasecmp(cType,"CNAME"))
	{
		char cZone[254];
		char cName[254];
		uRRType=5;
		if(!cParam1[0] || cParam2[0])
		{
			printf("<font color=yellow>Incorrect CNAME format: %s</font>\n\n",cLine);
			return;
		}
		if(cParam1[strlen(cParam1)-1]!='.')
		{
			printf("<font color=yellow>Incorrect FQDN missing period: %s</font>\n\n",cLine);
			return;
		}
		sprintf(cZone,"%s.",FQDomainName(cZoneName));
		strcpy(cName,FQDomainName(cParam1));
		if(strcmp(cName+strlen(cName)-strlen(cZone),cZone))
		{
			printf("<font color=white>Warning: CNAME RHS should probably end with zone: %s</font>\n\n",cLine);
			//return;
		}
	}
	else if(!strcasecmp(cType,"NS"))
	{
		MYSQL_RES *res;
		char cNS[100];

		uRRType=2;
		if(!cParam1[0] || cParam2[0])
		{
			printf("<font color=yellow>Incorrect NS format: %s</font>\n\n",cLine);
			return;
		}
		if(cParam1[strlen(cParam1)-1]!='.')
		{
			printf("<font color=yellow>Incorrect FQDN missing period: %s</font>\n\n",cLine);
			return;
		}

		//Get rid of last period for check
		strcpy(cNS,cParam1);
		cNS[strlen(cNS)-1]=0;
		sprintf(query,"SELECT uNameServer FROM tNameServer WHERE uNameServer=%u AND ( (cList LIKE '%s MASTER%%') OR (cList LIKE '%%%s SLAVE%%'))",uNameServer,cNS,cNS);

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) 
		{
			printf("%s\n",mysql_error(&mysql));
			Footer_ism3();
		}
		res=mysql_store_result(&mysql);
		if(mysql_num_rows(res)) 
		{
			printf("<font color=white>NS RR Ignored. Part of uNameServer cList</font>\n\n");
			return;
		}
		mysql_free_result(res);
	}
	else if(!strcasecmp(cType,"MX"))
	{
		unsigned uMX=0;
		uRRType=3;
		if(!cParam1[0] || !cParam2[0] )
		{
			printf("<font color=yellow>Missing MX param: %s</font>\n\n",cLine);
			return;
		}
		sscanf(cParam1,"%u",&uMX);
		if(uMX<1 || uMX>99999)
		{
			printf("<font color=yellow>Incorrect MX format: %s</font>\n\n",cLine);
			return;
		}
		if(cParam2[strlen(cParam2)-1]!='.')
		{
			printf("<font color=yellow>Incorrect FQDN missing period: %s</font>\n\n",cLine);
			return;
		}
	}
	else if(!strcasecmp(cType,"PTR"))
	{
		unsigned uFirstDigit=0;

		uRRType=7;
		if(!cParam1[0] || cParam2[0])
		{
			printf("<font color=yellow>Incorrect PTR format: %s</font>\n",cLine);
			return;
		}
		sscanf(cName,"%u.%*s",&uFirstDigit);
		if(!uFirstDigit)
		{
			//Check this rule again
			printf("<font color=yellow>Incorrect PTR LHS should start with a non zero digit: %s</font>\n",cLine);
			return;
		}

	}
	else if(1)
	{
		printf("<font color=yellow>RR Not recognized: %s</font>\n\n",cLine);
		return;
	}
	//hinfo, ptr, txt ignored

	//debug only
	//printf("cName:%s uTTL:%u uRRType:%u cType:%s cParam1:%s cParam2:%s cParam3:%s cParam4:%s\n\n",cName,uTTL,uRRType,cType,cParam1,cParam2,cParam3,cParam4); 

//Parse this mess and add RR's
//Valid known cases
//WWW CNAME domain.dom.
//ns2 NS domain.dom.
//mail IN A 12.12.12.12
//mail A 12.12.12.12
//1 PTR crap.isp.net
//Report unrecognized lines
			
		
	time(&clock);
	sprintf(query,"INSERT INTO tResource SET  uResource=0, uZone=%u, cName='%s', uTTL=0, uRRType=%u, cParam1='%s', cParam2='%s', cComment=' IMPORTED', uOwner=%u, uCreatedBy=1, uCreatedDate=%lu, uModBy=0, uModDate=0"
					,uZone
					,FQDomainName(cName)
					,uRRType
					,FQDomainName(cParam1)
					,FQDomainName(cParam2)
					,uCustId
					,(long unsigned)clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
		printf("<font color=yellow>%s</font>\n",mysql_error(&mysql));

}//void ProcessRRLine()


void Import(void)
{
#include <dirent.h>
	struct dirent **namelist;
	structSOA *importSOA;
	register int n,i;
	time_t clock;

	time(&clock);

	Header_ism3("Import()",0);
	printf("</center><font size=2><blockquote>\n");

	printf("Importing master zones from /usr/local/mysqlbind/import directory. File name must be same as zone name. Only A, CNAME, MX, PTR and NS records supported. SOA ttl values must be seconds. SOA NS must be in tNameServer.\n");

	printf("<pre>\n");
		
	n=scandir("/usr/local/mysqlbind/import", &namelist, 0, 0);
			
	if(n<0)
	{
		printf("scandir() error: Does /usr/local/mysqlbind/import exist?\n");
		Footer_ism3();
	}
	else if(n==2)
	{
		printf("No files found.\n");
		Footer_ism3();
	}

	for(i=0;i<n;i++)
	{

	if(namelist[i]->d_name[0]=='.' || strstr(namelist[i]->d_name+strlen(namelist[i]->d_name)-5,
				".done"))
	{
		;
	}
	else
	{
		FILE *fp;

		sprintf(query,"/usr/local/mysqlbind/import/%.100s", namelist[i]->d_name);
		if(!(fp=fopen(query,"r")))
		{
			printf("Could not open: %s\n",query);
			Footer_ism3();
		}

		//Start processing
		printf("%.100s<blockquote>", namelist[i]->d_name);
		
		importSOA=ProcessSOA(fp);

		//Add more rule based checking of TTLs	
		if(	importSOA->uTTL &&
			importSOA->uSerial &&
			importSOA->uRefresh &&
			importSOA->uRetry &&
			importSOA->uExp &&
			importSOA->uNegTTL &&
			importSOA->cHostmaster[0] )
		{
			MYSQL_RES *res;
			MYSQL_ROW field;
			unsigned uZone,uNameServer;

			//Import zone
		importSOA->cNameServer[strlen(importSOA->cNameServer)-1]=0;
		importSOA->cHostmaster[strlen(importSOA->cHostmaster)-1]=0;
			//debug only
			printf("uTTL=%u\n",importSOA->uTTL);
			printf("uSerial=%u\n",importSOA->uSerial);
			printf("uRefresh=%u\n",importSOA->uRefresh);
			printf("uRetry=%u\n",importSOA->uRetry);
			printf("uExp=%u\n",importSOA->uExp);
			printf("uNegTTL=%u\n",importSOA->uNegTTL);
			printf("cHostmaster=%s\n",importSOA->cHostmaster);
			printf("cNameServer=%s\n",importSOA->cNameServer);
sprintf(query,"SELECT uNameServer FROM tNameServer WHERE cList like '%s MASTER%%'",importSOA->cNameServer);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql)) 
			{
				printf("%s\n",mysql_error(&mysql));
				Footer_ism3();
			}
			res=mysql_store_result(&mysql);
			if(!mysql_num_rows(res)) 
			{
				printf("Must configure tNameServer for %s MASTER\n",importSOA->cNameServer);
				Footer_ism3();
			}
			if((field=mysql_fetch_row(res)))
				sscanf(field[0],"%u",&uNameServer);
			mysql_free_result(res);

			//uZoneTTL is the NegTTL
			printf("Importing zone\n");
sprintf(query,"INSERT INTO tZone SET  uZone=0, cZone='%s', uNameServer=%u, uSerial=%u, uExpire=%u, uRefresh=%u, uTTL=%u, uRetry=%u, uZoneTTL=%u, uMailServers=0, cMainAddress='0.0.0.0', uOwner=1, uCreatedBy=1, uCreatedDate=%lu, uModBy=0, uModDate=0, cHostmaster='%s IMPORTED'"
			,FQDomainName(namelist[i]->d_name)
			,uNameServer
			,importSOA->uSerial
			,importSOA->uExp
			,importSOA->uRefresh
			,importSOA->uTTL
			,importSOA->uRetry
			,importSOA->uNegTTL
			,clock
			,importSOA->cHostmaster);

			mysql_query(&mysql,query);
			if(mysql_errno(&mysql)) 
			{
				printf("<font color=yellow>%s</font>\n",
					mysql_error(&mysql));
				printf("</blockquote>");
				continue;
			}
			uZone=mysql_insert_id(&mysql);

			//Process rest of file for RRs
			printf("Importing RRs\n");
			while(fgets(query,254,fp)!=NULL)
			{
			  //skip empty lines
			  if(query[0]!='\n')
				ProcessRRLine(query,
					FQDomainName(namelist[i]->d_name),
					uZone,1,uNameServer);
			}
		}
		else
		{
			printf("Could not process SOA correctly\n");
			printf("uTTL=%u\n",importSOA->uTTL);
			printf("uSerial=%u\n",importSOA->uSerial);
			printf("uRefresh=%u\n",importSOA->uRefresh);
			printf("uRetry=%u\n",importSOA->uRetry);
			printf("uExp=%u\n",importSOA->uExp);
			printf("uNegTTL=%u\n",importSOA->uNegTTL);
			printf("cHostmaster=%s\n",importSOA->cHostmaster);
			printf("cNameServer=%s\n",importSOA->cNameServer);
			Footer_ism3();
		}

	
		printf("</blockquote>");	
		fclose(fp);

	}

	}//for

	printf("</blockquote></pre>\n");
	Footer_ism3();

}//void Import(void)


structSOA *ProcessSOA(FILE *fp)
{
	static structSOA importSOA;
	register unsigned uIn=0;
	register unsigned uParamCount=0;
	char *cp;

	importSOA.uSerial=0;
	importSOA.uTTL=86400;
	importSOA.uRefresh=0;
	importSOA.uRetry=0;
	importSOA.uExp=0;
	importSOA.uNegTTL=0;
	importSOA.cHostmaster[0]=0;
	importSOA.cNameServer[0]=0;

	while(fgets(query,254,fp)!=NULL)
	{
		//debug only
		printf("%s",query);

		if(strstr(query,"("))
		{
			if((cp=strstr(query,"SOA")) || (cp=strstr(query,"soa")))
				sscanf(cp+4,"%s %s",importSOA.cNameServer,
						importSOA.cHostmaster);
			uIn=1;
			continue;
		}
		else if(strstr(query,")"))
		{
			if(uIn && uParamCount==4)
				sscanf(query,"%u",&importSOA.uNegTTL);
			return(&importSOA);
		}
		else if(strstr(query,"$TTL"))
			sscanf(query,"$TTL %u",&importSOA.uTTL);
		else if((cp=strstr(query,"SOA")) || (cp=strstr(query,"soa")))
			sscanf(cp+4,"%s %s",importSOA.cNameServer,
						importSOA.cHostmaster);

		if(uIn)
		{
			if(!uParamCount)
				sscanf(query,"%u",&importSOA.uSerial);
			else if(uParamCount==1)
				sscanf(query,"%u",&importSOA.uRefresh);
			else if(uParamCount==2)
				sscanf(query,"%u",&importSOA.uRetry);
			else if(uParamCount==3)
				sscanf(query,"%u",&importSOA.uExp);
			else if(uParamCount==4)
				sscanf(query,"%u",&importSOA.uNegTTL);
			uParamCount++;
		}

		if(uParamCount>5)
			return(&importSOA);
	}
	
	return(&importSOA);

}//structSOA *ProcessSOA(FILE *fp)


//Shell commands
char *GetRRType(unsigned uRRType)
{
	MYSQL_RES *res;
	static char cRRType[100];
	
	strcpy(cRRType,"unknown");

	sprintf(query,"SELECT cLabel FROM tRRType WHERE uRRType=%u",uRRType);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)==1) 
	{
		MYSQL_ROW field;
		if((field=mysql_fetch_row(res)))
			strcpy(cRRType,field[0]);

	}
	mysql_free_result(res);
	return(cRRType);

}//char *GetRRType(unsigned uRRType)


void PrintNSList(FILE *zfp,char *cuNameServer)
{
	MYSQL_RES *res;

	sprintf(query,"SELECT cList FROM tNameServer WHERE uNameServer=%s",
			cuNameServer);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)==1) 
	{
		MYSQL_ROW field;
		register int i=0,j=0;

		if((field=mysql_fetch_row(res)))
		{
			//parse out
			while(field[0][i])
			{
				if(field[0][i]=='\n' || field[0][i]==0)
				{
					field[0][i]=0;
					fprintf(zfp,"\t\tNS %s.\n",
						FQDomainName(field[0]+j));
					i++;
					j=i;
				}
				i++;
			}
			if(field[0][j]) fprintf(zfp,"\t\tNS %s.\n",
					FQDomainName(field[0]+j));
		}
	}
	mysql_free_result(res);

}//PrintNSList(FILE *fp,char *cuNameServer)


void PrintMXList(FILE *zfp,char *cuMailServers)
{
	MYSQL_RES *res;

	sprintf(query,"SELECT cList FROM tMailServer WHERE uMailServer=%s",
			cuMailServers);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)==1) 
	{
		MYSQL_ROW field;
		register int i=0,j=0,uMX=10;

		if((field=mysql_fetch_row(res)))
		{
			//parse out
			while(field[0][i])
			{
				if(field[0][i]=='\n' || field[0][i]==0)
				{
					field[0][i]=0;
					fprintf(zfp,"\t\tMX %d %s.\n",
							uMX,
							FQDomainName(field[0]+j));
					i++;
					j=i;
					uMX+=10;
				}
				i++;
			}
			if(field[0][j]) fprintf(zfp,"\t\tMX %d %s.\n",
					uMX,
					FQDomainName(field[0]+j));
		}
	}
	mysql_free_result(res);
}//PrintMXList(FILE *fp,char *cuMailServers)


void CreateMasterFiles(char *cMasterNS, char *cZone, unsigned uModDBFiles, 
		unsigned uModStubs)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	MYSQL_RES *res2;
	MYSQL_ROW field2;
	FILE *sfp=NULL;
	FILE *zfp=NULL;
	unsigned uZone=0;
	unsigned uRRType=0;
	char cTTL[16]={""};
	
	//0 cZone
	//1 uZone
	//2 uNameServer
	//3 cHostmaster
	//4 uSerial
	//5 uTTL
	//6 uExpire
	//7 uRefresh
	//8 uRetry
	//9 uZoneTTL
	//10 uMailServers
	//11 cMainAddress

	if(cZone[0])	
	sprintf(query,"SELECT tZone.cZone,tZone.uZone,tZone.uNameServer,tZone.cHostmaster,tZone.uSerial,tZone.uTTL,tZone.uExpire,tZone.uRefresh,tZone.uRetry,tZone.uZoneTTL,tZone.uMailServers,tZone.cMainAddress FROM tZone,tNameServer WHERE tZone.uNameServer=tNameServer.uNameServer AND tNameServer.cList LIKE '%%%s MASTER%%' AND tZone.cZone='%s'",cMasterNS,cZone);
	else
	sprintf(query,"SELECT tZone.cZone,tZone.uZone,tZone.uNameServer,tZone.cHostmaster,tZone.uSerial,tZone.uTTL,tZone.uExpire,tZone.uRefresh,tZone.uRetry,tZone.uZoneTTL,tZone.uMailServers,tZone.cMainAddress FROM tZone,tNameServer WHERE tZone.uNameServer=tNameServer.uNameServer AND tNameServer.cList LIKE '%%%s MASTER%%' ORDER BY tZone.cZone",cMasterNS);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)<1) 
	{
		printf("No zones found for master NS %s\n"
						,cMasterNS);
		return;
	}


	if(uModStubs)
	{
		if(cZone[0])
			strcpy(query,"a");
		else
			strcpy(query,"w");
		if(!(sfp=fopen("/usr/local/mysqlbind/named.d/master.zones",query)))
		{
			fprintf(stderr,"Could not open master.zones\n");
			exit(1);
		}
	}


	while((field=mysql_fetch_row(res)))
	{
		//debug only
		printf("%s\n",field[0]);
		sscanf(field[1],"%u",&uZone);

		if(uModStubs)
		{
			//write stub into include file		
			fprintf(sfp,"zone \"%s\" {\n",field[0]);
			fprintf(sfp,"\ttype master;\n");
			fprintf(sfp,"\tfile \"master/%c/%s\";\n};\n\n",
					field[0][0],field[0]);
		}

	if(uModDBFiles)
	{
		char *cp;

		//write master db file
		sprintf(query,"/usr/local/mysqlbind/named.d/master/%c/%s",field[0][0],field[0]);
		if(!(zfp=fopen(query,"w")))
		{
			fprintf(stderr,"Could not open master zone db file\n");
			exit(1);
		}

	//0 cZone
	//1 uZone
	//2 uNameServer
	//3 cHostmaster
	//4 uSerial
	//
	//5 uTTL default TTL macro directive $TTL. See bind 8.2.x docs
	//
	//6 uExpire
	//7 uRefresh
	//8 uRetry
	//9 uZoneTTL is the negative response caching value in the SOA.
	//  See bind 8.2.x docs
	//
	//10 uMailServers
	//11 cMainAddress
	
		if((cp=strchr(field[3],' '))) *cp=0;

		fprintf(zfp,"; %s\n",field[0]);
		fprintf(zfp,"$TTL %s\n",field[5]);
		
		fprintf(zfp,
		"@ IN SOA %s. %s. (\n",cMasterNS,field[3]);
		fprintf(zfp,"\t\t\t%s\t;serial\n",field[4]);
		fprintf(zfp,"\t\t\t%s\t\t;slave refresh\n",field[7]);
		fprintf(zfp,"\t\t\t%s\t\t;slave retry\n",field[8]);
		fprintf(zfp,"\t\t\t%s\t\t;slave expiration\n",field[6]);
		fprintf(zfp,"\t\t\t%s )\t\t;negative ttl\n\n",
				field[9]);
		

		//ns
		PrintNSList(zfp,field[2]);

		//mx1
		PrintMXList(zfp,field[10]);
		
		//in a 0.0.0.0 is the null IP number
		if(field[11][0]!='0')
				fprintf(zfp,"\t\tA %s\n;\n",field[11]);
		fprintf(zfp,";\n");

		//TODO
		if(!strcmp(field[0]+strlen(field[0])-5,".arpa"))
		{
sprintf(query,"SELECT cName,uTTL,uRRType,cParam1,cParam2,cComment FROM tResource WHERE uZone=%u",uZone);
		}
		else
		{
sprintf(query,"SELECT cName,uTTL,uRRType,cParam1,cParam2,cComment FROM tResource WHERE uZone=%u ORDER BY cName",uZone);
		}

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) 
		{
			fprintf(stderr,"%s\n",mysql_error(&mysql));
			exit(1);
		}
		res2=mysql_store_result(&mysql);
		while((field2=mysql_fetch_row(res2)))
		{

			sscanf(field2[2],"%u",&uRRType);
			if(field2[1][0]!='0') strcpy(cTTL,field2[1]);

				fprintf(zfp,"%s\t%s\t%s\t%s\t%s\n",
						field2[0],
						cTTL,
						GetRRType(uRRType),
						field2[3],
						field2[4]);
		}
		mysql_free_result(res2);
	}//if uModDBFile
		if(zfp) fclose(zfp);

	}
	mysql_free_result(res);
	if(sfp) fclose(sfp);
}//void CreateMasterFiles(char *cMasterNS)


void CreateSlaveFiles(char *cSlaveNS, char *cZone, char *cMasterIP)
{
	//Create all slave zone stubs in include file.
	MYSQL_RES *res;
	MYSQL_ROW field;
	FILE *fp;
	
	if(cZone[0])	
	sprintf(query,"SELECT tZone.cZone FROM tZone,tNameServer WHERE tZone.uNameServer=tNameServer.uNameServer AND tNameServer.cList LIKE '%%%s SLAVE%%' AND tZone.cZone='%s'",cSlaveNS,cZone);
	else
	sprintf(query,"SELECT tZone.cZone FROM tZone,tNameServer WHERE tZone.uNameServer=tNameServer.uNameServer AND tNameServer.cList LIKE '%%%s SLAVE%%' ORDER BY tZone.cZone",cSlaveNS);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)<1) 
	{
		printf("No zones found for slave NS %s\n"
						,cSlaveNS);
		return;
	}
	
	if(cZone[0])
		strcpy(query,"a");
	else
		strcpy(query,"w");
	if(!(fp=fopen("/usr/local/mysqlbind/named.d/slave.zones",query)))
	{
		fprintf(stderr,"Could not open slave.zones\n");
		exit(1);
	}


	while((field=mysql_fetch_row(res)))
	{
		//debug only
		printf("%s\n",field[0]);
		fprintf(fp,"zone \"%s\" {\n",field[0]);
		fprintf(fp,"\ttype slave;\n");
		fprintf(fp,"\tmasters { %s; };\n",cMasterIP);
		fprintf(fp,"\tfile \"slave/%c/%s\";\n};\n\n",
				field[0][0],field[0]);
	}
	fclose(fp);

}//void CreateSlaveFiles();


void InstallNamedFiles(char *cIpNum)
{
	char cISMROOT[256]={""};
#ifdef BIND9
	char cSetupDir[16]={"setup9"};
#else
	char cSetupDir[16]={"setup"};
#endif
	register char i;


	if(getenv("ISMROOT")!=NULL)
	{               
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}
	
	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. setenv ISMROOT /home/ism-3.0\n");
		exit(0);
	}

	printf("Installing named for IP %s from %s/mysqlBind\n",
			IPNumber(cIpNum), cISMROOT);
	
	mkdir("/usr/local/mysqlbind",0777);
	mkdir("/usr/local/mysqlbind/named.d",0777);
	mkdir("/usr/local/mysqlbind/named.d/master",0777);
	mkdir("/usr/local/mysqlbind/named.d/slave",0777);

	printf("Configuring and installing files...\n");

	//Create dir hierarchy	
	for(i='0';i<='9';i++)
	{
		sprintf(query,"/usr/local/mysqlbind/named.d/master/%c",i);
		mkdir(query,0777);
		sprintf(query,"/usr/local/mysqlbind/named.d/slave/%c",i);
		mkdir(query,0777);
	}
	for(i='a';i<='z';i++)
	{
		sprintf(query,"/usr/local/mysqlbind/named.d/master/%c",i);
		mkdir(query,0777);
		sprintf(query,"/usr/local/mysqlbind/named.d/slave/%c",i);
		mkdir(query,0777);
	}

	sprintf(query,"cat %s/mysqlBind/%s/named.conf|sed -e \"s/{{cIpNumber}}/%s/g\" > /usr/local/mysqlbind/named.conf",cISMROOT,cSetupDir,IPNumber(cIpNum));	
	if(system(query))
		 printf("Error configuring named.conf\n");

	sprintf(query,"touch /usr/local/mysqlbind/named.d/master.zones");	
	if(system(query))
		 printf("Error configuring master.zones\n");

	sprintf(query,"touch /usr/local/mysqlbind/named.d/slave.zones");	
	if(system(query))
		 printf("Error configuring slave.zones\n");

	sprintf(query,"cat %s/mysqlBind/%s/localhost > /usr/local/mysqlbind/named.d/master/localhost",cISMROOT,cSetupDir);	
	if(system(query))
		 printf("Error configuring localhost\n");

	sprintf(query,"cat %s/mysqlBind/%s/127.0.0 > /usr/local/mysqlbind/named.d/master/127.0.0",cISMROOT,cSetupDir);	
	if(system(query))
		 printf("Error configuring 127.0.0\n");

	sprintf(query,"cat %s/mysqlBind/%s/root.cache > /usr/local/mysqlbind/named.d/root.cache",cISMROOT,cSetupDir);	
	if(system(query))
		 printf("Error configuring root.cache\n");

/*	
	
	printf("Checking for correct named executable...\n");
	sprintf(query,"/usr/sbin/named -v |grep 8.2.5");	
	if(system(query))
	{
	fprintf(stderr,"ERROR /usr/sbin/named wrong version or inexistant\n");
		exit(1);
	}
	
#ifdef BIND9
	printf("Checking for BIND 9 rndc executable...\n");
	sprintf(query,"ls /usr/sbin/rndc");	
#else
	printf("Checking for BIND 8 ndc executable...\n");
	sprintf(query,"ls /usr/sbin/ndc");	
#endif
	if(system(query))
	{
#ifdef BIND9
	fprintf(stderr,"ERROR BIND 9 /usr/sbin/rndc not found\n");
#else
	fprintf(stderr,"ERROR BIND 8 /usr/sbin/ndc not found\n");
#endif
		exit(1);
	}

	printf("Starting new named server...\n");
#ifdef Linux
	system("killall named");
#endif
	sprintf(query,"/usr/sbin/named -b /usr/local/mysqlbind/named.conf");	
	if(system(query))
	{
	fprintf(stderr,"ERROR could not start named\n");
		exit(1);
	}

	printf("Checking named server...\n");
#ifdef BIND9
	sprintf(query,"sleep 2;/usr/sbin/rndc status | tail -1 | grep \"server is up\"");	
#else
	sprintf(query,"sleep 2;/usr/sbin/ndc -c /var/run/ndc-mysqlbind status | tail -1 | grep \"server is up\"");	
#endif
	if(system(query))
	{
	fprintf(stderr,"ERROR named may have problems\n");
		system("tail /var/log/named.log");
		exit(1);
	}
*/
	
	printf("Done.\n");
	exit(0);


}//void InstallNamedFiles(char *cIpNum)


void SerialNum(char *serial)
{
	time_t clock;
		
	//Make new today serial number
	time(&clock);
	strftime(serial,12,"%Y%m%d00",localtime(&clock));

}//void SerialNum(char *serial)


void ExportTable(char *cTable, char *cFile)
{
	printf("ExportTable() Not implemented yet\n");
	exit(0);
}//void ExportTable(char *cTable, char *cFile)


void ConnectMysqlServer(void)
{
	char *cEffectiveDbIp=DBIP;
	char cRemoteDbName[256]={DBNAME};
	char cRemoteDbIp[256]={""};
	char cRemoteDbPwd[256]={DBPASSWD};
	char cRemoteDbLogin[256]={DBLOGIN};


	//Read dbip,dbname (same as mySQL user name), and sourceip (passwd).	
	ConnectDb();
	GetConfiguration("cRemoteDbPwd",cRemoteDbPwd,0);
	GetConfiguration("cRemoteDbName",cRemoteDbName,0);
	GetConfiguration("cRemoteDbIp",cRemoteDbIp,0);
	GetConfiguration("cRemoteDbLogin",cRemoteDbLogin,0);

	if(cRemoteDbIp[0]) cEffectiveDbIp=cRemoteDbIp;//See local.h
	
	mysql_init(&mysql);
	if (!mysql_real_connect(&mysql,cEffectiveDbIp,cRemoteDbLogin,cRemoteDbPwd
				,cRemoteDbName,0,NULL,0))
	{
		fprintf(stderr,"Database server unavailable %s %s %s %s %s\n",
				cEffectiveDbIp,cRemoteDbLogin,cRemoteDbPwd,cRemoteDbName,
				mysql_error(&mysql));
		exit(1);
	}

}//void ConnectMysqlServer(void)


void SlaveJobQueue(char *cNameServer, char *cMasterIP)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	time_t clock;
	register int first=1;
	char cCurrentZone[100]={" "};
	unsigned uModify=0;
	unsigned uNew=0;
	unsigned uDelete=0;
	unsigned uDeleteFirst=0;
	unsigned uChanged=0;
	

	ConnectMysqlServer();

	time(&clock);
	sprintf(query,"SELECT uJob,cJob,cZone,uMasterJob FROM tJob WHERE cTargetServer='%s SLAVE' AND uTime<=%lu ORDER BY cZone,uJob",cNameServer,clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		printf("%s -1\n",mysql_error(&mysql));
		exit(1);
	}

	res=mysql_store_result(&mysql);
	if(mysql_num_rows(res)) 
	{
		MYSQL_RES *res2;

		while((field=mysql_fetch_row(res)))
		{
			//If MASTER job still in queue skip
		sprintf(query,"SELECT uJob FROM tJob WHERE uMasterJob=%s AND cTargetServer like '%% MASTER'",field[3]);
			mysql_query(&mysql,query);
			//printf("%s\n",query);
			if(mysql_errno(&mysql)) 
			{
				printf("%s\n",mysql_error(&mysql));
				exit(1);
			}
			res2=mysql_store_result(&mysql);
			if(mysql_num_rows(res2)) 
			{
					mysql_free_result(res2);
					//Ignore this job until MASTER
					//handles it.
					printf("Skipping job not yet handled by MASTER\n");
					continue;
			}
			mysql_free_result(res2);
			

			if(strcmp(field[2],cCurrentZone))
			{
				if(!first)
				{
					//debug only
		printf("uDelete=%u uModify=%u uNew=%u uDeleteFirst=%u\n",
						uDelete,uModify,uNew,uDeleteFirst); 
		uChanged+=ProcessSlaveJob(cCurrentZone,uDelete,uModify,
				uNew,uDeleteFirst,cNameServer,cMasterIP);
					uModify=0;
					uNew=0;
					uDelete=0;
					uDeleteFirst=0;
				}
				else
				{
					first=0;
				}
				strcpy(cCurrentZone,field[2]);
			}
			printf("%s\t%s\t%s\n",field[0],field[2],field[1]);
			if(strstr(field[1],"New")) uNew++;
			else if(strstr(field[1],"Modify")) uModify++;
			else if(strstr(field[1],"Delete")) uDelete++;
			if(uDelete && !uNew) uDeleteFirst=1;

			//Remove job from queue
			sprintf(query,"DELETE FROM tJob WHERE uJob=%s",field[0]);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql)) 
			{
				printf("%s\n",mysql_error(&mysql));
				exit(1);
			}

		}
	}

	if(!first)
	{
		//debug only
		printf("uDelete=%u uModify=%u uNew=%u uDeleteFirst=%u\n",
						uDelete,uModify,uNew,uDeleteFirst); 
		uChanged+=ProcessSlaveJob(cCurrentZone,uDelete,uModify,
				uNew,uDeleteFirst,cNameServer,cMasterIP);
	}
	mysql_free_result(res);
	
	if(uChanged)
	{
		//Check to see if reconfigure is ok for slaves
#ifdef BIND9
		if(system("/usr/sbin/rndc reconfig"))
#else
		if(system("/usr/sbin/ndc -c /var/run/ndc-mysqlbind reconfig"))
#endif
			exit(1);
	}

	exit(0);

}//void SlaveJobQueue()


void MasterJobQueue(char *cNameServer)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	time_t clock;
	register int first=1;
	char cCurrentZone[100]={" "};
	unsigned uModify=0;
	unsigned uNew=0;
	unsigned uDelete=0;
	unsigned uDeleteFirst=0;
	unsigned uChanged=0;
	char *cp;
	

	ConnectDb();

	time(&clock);
	sprintf(query,"SELECT uJob,cJob,cZone,cJobData FROM tJob WHERE cTargetServer='%s MASTER' AND uTime<=%lu ORDER BY cZone,uJob",cNameServer,clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	res=mysql_store_result(&mysql);
	if(mysql_num_rows(res)) 
	{

		while((field=mysql_fetch_row(res)))
		{
			if(strcmp(field[2],cCurrentZone))
			{
				if(!first)
				{
					//debug only
		printf("uDelete=%u uModify=%u uNew=%u uDeleteFirst=%u\n",
						uDelete,uModify,uNew,uDeleteFirst); 
		uChanged+=ProcessMasterJob(cCurrentZone,uDelete,uModify,
				uNew,uDeleteFirst,cNameServer);
					uModify=0;
					uNew=0;
					uDelete=0;
					uDeleteFirst=0;
				}
				else
				{
					first=0;
				}
				strcpy(cCurrentZone,field[2]);
			}
			printf("%s\t%s\t%s\n",field[0],field[2],field[1]);
			if(strstr(field[1],"New")) uNew++;
			else if(strstr(field[1],"Modify")) uModify++;
			else if(strstr(field[1],"Delete")) uDelete++;
			if(uDelete && !uNew) uDeleteFirst=1;

			//Inform ext queue of completion. Only for MASTER
			//no error checking takes place fix this.
			if(!strncmp(field[1],"Ext",3) && (cp=strstr(field[3],"uJob=")))
			{
				char cMsg[33];
				unsigned uExtJob=0;

				ExtConnectDb(0);
				sprintf(cMsg,"mysqlBind.%.20s",field[1]);
				sscanf(cp+5,"%u",&uExtJob);
				InformExtJob(cMsg,cNameServer,
						uExtJob,mysqlISP_Deployed);
			}

			//Remove job from queue
			sprintf(query,"DELETE FROM tJob WHERE uJob=%s",field[0]);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql)) 
			{
				printf("%s\n",mysql_error(&mysql));
				exit(1);
			}

		}
	}

	if(!first)
	{
		//debug only
		printf("uDelete=%u uModify=%u uNew=%u uDeleteFirst=%u\n",
						uDelete,uModify,uNew,uDeleteFirst); 
		if((uChanged=ProcessMasterJob(cCurrentZone,uDelete,uModify,
				uNew,uDeleteFirst,cNameServer)))
		{
			if(uChanged==2)
				uReconfig=1;
			else if(uChanged==3)
				uReload=1;
		}
	}
	mysql_free_result(res);
	
	if(uReload)
	{
#ifdef BIND9
		if(system("/usr/sbin/rndc reload"))
#else
		if(system("/usr/sbin/ndc -c /var/run/ndc-mysqlbind reload"))
#endif
			exit(1);
	}
	else if(uReconfig)
	{
#ifdef BIND9
		if(system("/usr/sbin/rndc reconfig"))
#else
		if(system("/usr/sbin/ndc -c /var/run/ndc-mysqlbind reconfig"))
#endif
			exit(1);
	}

	exit(0);

}//void MasterJobQueue(char *cNameServer)


int ProcessMasterJob(char *cZone,unsigned uDelete,unsigned uModify,unsigned uNew, unsigned uDeleteFirst, char *cMasterNS)
{
	//return 0 if nothing needs to be done
	//return 1 if zone info has changed
	//return 2 if zone is added or deleted
	//return 3 if zone is modified but we need a reload anyway
	//debug only
	printf("Queue Policy for %s: ",cZone);
	if(uDelete && !uNew)
	{
		//debug only
		printf("Delete\n\n");
		//Replace master.zones named.conf include file
		//All Zones replace, DBFiles No, Stubs Yes
		CreateMasterFiles(cMasterNS,"",0,1);
		return(2);
	}
	else if(uDelete && uNew && !uDeleteFirst)
	{
		//debug only
		printf("New then Delete\n\n");
		return(0);
	}
	else if(uNew)
	{
		//debug only
		printf("New\n\n");
		//Append to master.zones named.conf include file
		//Single zone append, DBFiles yes, Stubs yes
		CreateMasterFiles(cMasterNS,cZone,1,1);
		return(2);
	}
	else if(uModify)
	{
		//debug only
		printf("Modify\n\n");
		//Single zone, DBFiles yes, Stubs no
		sprintf(query,"grep 'zone \"%s\"' /usr/local/mysqlbind/named.d/master.zones > /dev/null",cZone);
		if(system(query))
		{
			CreateMasterFiles(cMasterNS,"",1,1);
			return(3);
		}
		else
		{
			CreateMasterFiles(cMasterNS,cZone,1,0);
			//Single zone reload
			if(!uReload)//Set by return(3) above global
#ifdef BIND9
	sprintf(query,"/usr/sbin/rndc reload %s",cZone);
#else
	sprintf(query,"/usr/sbin/ndc -c /var/run/ndc-mysqlbind reload %s",cZone);
#endif
		system(query);
		}
		return(1);
	}
	
	return(0);

}//int ProcessMasterJob();


int ProcessSlaveJob(char *cZone,unsigned uDelete,unsigned uModify,unsigned uNew, unsigned uDeleteFirst, char *cMasterNS, char *cMasterIP)
{
	char cSystem[512];

	//debug only
	printf("Queue Policy for %s: ",cZone);
	if(uDelete && !uNew)
	{
		//debug only
		printf("Delete\n\n");
		//Replace slave.zones named.conf include file
		//All Zones replace
		CreateSlaveFiles(cMasterNS,"",cMasterIP);
		return(1);
	}
	else if(uDelete && uNew && !uDeleteFirst)
	{
		//debug only
		printf("New then Delete\n\n");
		return(0);
	}
	else if(uNew)
	{
		//debug only
		printf("New\n\n");
		//Append to slave.zones named.conf include file
		//Single zone append
		CreateSlaveFiles(cMasterNS,cZone,cMasterIP);
		return(1);
	}
	else if(uModify)
	{
		//debug only
		printf("Modify\n\n");
#ifdef BIND9
		sprintf(cSystem,"/usr/sbin/rndc reload %s",cZone);
#else
		sprintf(cSystem,"/usr/sbin/ndc -c /var/run/ndc-mysqlbind reload %s",cZone);
#endif
		system(cSystem);
		return(0);
	}
	
	return(0);

}//int ProcessSlaveJob();


void GenerateArpaZones(void)
{
	MYSQL_RES *res;

	char cZone[100];
	unsigned uZone=0;
	

	//Zone A Records
	sprintf(query,"SELECT cZone,cMainAddress,uZone FROM tZone WHERE cZone NOT LIKE '%%.arpa'");
	mysql_query(&mysql,query);

	if(mysql_errno(&mysql)) 
		tZone(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	
	Header_ism3("GenerateArpaZones()",0);
	printf("</center><font size=2><pre>\n");

	if(mysql_num_rows(res)) 
	{
		MYSQL_ROW field;
		while((field=mysql_fetch_row(res)))
		{
			strcpy(cZone,field[0]);
			sscanf(field[2],"%u",&uZone);
			
			if(PopulateArpaZone(field[0],field[1],0,uZone)) continue;

		}
	}
	mysql_free_result(res);
	
	
	//A Resource Records
	sprintf(query,"SELECT tZone.cZone,tResource.cParam1,tResource.cName,tZone.uZone FROM tResource,tZone,tRRType WHERE tResource.uZone=tZone.uZone AND tResource.uRRType=tRRType.uRRType AND tRRType.cLabel='A'");
	mysql_query(&mysql,query);

	if(mysql_errno(&mysql)) 
	{
		printf("%s\n",mysql_error(&mysql));
		Footer_ism3();
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)) 
	{
		MYSQL_ROW field;
		while((field=mysql_fetch_row(res)))
		{
			//If cName=field[2] if FQDN leave as is else
			//add zone to it.
			if(field[2][strlen(field[2])-1]=='.')
				sprintf(cZone,"%s",field[2]);
			else if(field[2][0] && field[2][0]!='\t')
				sprintf(cZone,"%s.%s",field[2],field[0]);
			//default case
			else if(1)
				sprintf(cZone,"%s",field[0]);

			//debug only
			//printf("(%s) (%s) (%s) [%s]\n",
			//		field[2],field[0],cZone,field[1]);
			//Footer_ism3();

			sscanf(field[3],"%u",&uZone);
			if(PopulateArpaZone(cZone,field[1],0,uZone)) continue;
		}
	}
	mysql_free_result(res);

	printf("Remember to select and remove duplicate PTR records from .arpa zones now.\n");
	Footer_ism3();

}//void GenerateArpaZones(void)


int PopulateArpaZone(char *cZone, char *cIPNum, unsigned uHtmlMode, unsigned uFromZone)
{
	unsigned a=0,b=0,c=0,d=0;
	MYSQL_RES *res2;
	MYSQL_ROW field;
	unsigned uZone=0;
	unsigned uNew=0;
	unsigned uNameServer=0;
	time_t clock;
	char cArpaZone[64];


	time(&clock);

	sscanf(cIPNum,"%u.%u.%u.%u",&a,&b,&c,&d);
			
	if(!uHtmlMode)
		printf("<u>%s %u.%u.%u.%u</u>\n",cZone,a,b,c,d);

	if(a==0 || d==0 || a>254 || b>254 || c>254 || d>254) return(1);
	sprintf(cArpaZone,"%u.%u.%u.in-addr.arpa",c,b,a);
sprintf(query,"SELECT cZone,uZone,uNameServer FROM tZone WHERE cZone='%s'",cArpaZone);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		if(uHtmlMode)
			tZone(mysql_error(&mysql));
		else
			printf("%s\n",mysql_error(&mysql));
		return(1);
	}
	res2=mysql_store_result(&mysql);
	if(!mysql_num_rows(res2)) 
	{
		char cHostmaster[100];

		if(!uHtmlMode)
			printf("<font color=yellow>Adding new arpa zone: %s</font>\n",cArpaZone);
		strcpy(cHostmaster,ForeignKey("tZone","cHostmaster",uFromZone));
		sscanf(ForeignKey("tZone","uNameServer",uFromZone),
				"%u",&uNameServer);
		if(AddNewArpaZone(cArpaZone,uNameServer,cHostmaster)) 
		{
			if(uHtmlMode)
				tZone(mysql_error(&mysql));
			else
				printf("Error: %s\n",mysql_error(&mysql));
			return(1);//tzonefunc.h
		}
		uZone=mysql_insert_id(&mysql);
		uNew=1;

	}
	else if((field=mysql_fetch_row(res2)))
	{
		sscanf(field[1],"%u",&uZone);
		sscanf(field[2],"%u",&uNameServer);
	}

	mysql_free_result(res2);

	if(uZone)
	{
		if(!uHtmlMode)
			printf("Adding RR to arpa zone: uZone=%u\n",uZone);

		//Add PTR record 
		if(AddPTRResource(d,cZone,uZone)) 
		{
			if(uHtmlMode)
				tZone(mysql_error(&mysql));
			else
				printf("Error: %s\n",mysql_error(&mysql));
			return(1);
		}

		//TODO check clock+60 and new arpa zone job
		if(uHtmlMode && !uNew && uNameServer)
			SubmitJob("Modify",uNameServer,cArpaZone,0,clock);
		else if(uHtmlMode && uNew && uNameServer)
			SubmitJob("New",uNameServer,cArpaZone,0,clock);
		UpdateSerialNum(uZone);
	}

	//TODO what is this for comments please!
	if(uHtmlMode && uNew && uFromZone)
	{
		SubmitJob("New",uNameServer,cArpaZone,0,clock);
	}
	return(0);

}//int PopulateArpaZone()


int FetchNameServer(char *cList, char *cNameServer);

void Status(char *cTarget)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	sprintf(query,"SELECT cList,cLabel FROM tNameServer");
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
		mysqlBind(mysql_error(&mysql));

	Header_ism3("Status()",0);
	printf("</center><font size=2><pre>Checking all name servers by group with dig %s %s\n\n<blockquote>",(cTarget[0]) ? "for" : "" ,cTarget);

	res=mysql_store_result(&mysql);
	while((field=mysql_fetch_row(res)))
	{
		char cNameServer[100];
		unsigned uMaster=0;
		
		printf("%s<blockquote>",field[1]);
		while((uMaster=FetchNameServer(field[0],cNameServer)))
		{

			if(cTarget[0])
			sprintf(query,
			"dig @%s %s > /tmp/mysqlbind.status 2>&1"
					,cGetMainAddress(cNameServer),cTarget);
			else
			sprintf(query,
			"dig @%s %s > /tmp/mysqlbind.status 2>&1"
					,cGetMainAddress(cNameServer),cNameServer);
			system(query);
			printf("\n---%s\n",(uMaster==1) ? "Master" : "Slave");
			PassDirectHtml("/tmp/mysqlbind.status");
		}
		printf("</blockquote>");
	}
	mysql_free_result(res);

	printf("</blockquote></pre>");
	Footer_ism3();

}//void Status(char *cTarget)


char *cGetMainAddress(char *cNameServer)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	static char cMainAddress[100]={""};

	sprintf(query,"SELECT cMainAddress FROM tZone WHERE cZone='%s'",
			cNameServer);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
		mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	if((field=mysql_fetch_row(res)))
	{
		strcpy(cMainAddress,field[0]);
	}
	else
	{
		strcpy(cMainAddress,cNameServer);
	}
	mysql_free_result(res);

	return(cMainAddress);

}//char *cGetMainAddress(char *cNameServer)


int FetchNameServer(char *cList, char *cNameServer)
{
	static char *cpList=NULL;
	char *cp,*cp2;
	int retval=0;

	//cList has the following format if ok
	//ns1.yourisp.net MASTER
	//ns(N-1).yourisp.net SLAVE
	//ns(N).yourisp.net SLAVE
	
	//return 1 if MASTER
	//return 2 if SLAVE, assume if not MASTER SLAVE
	//return 0 if no more
	//set cNameServer to current NS
	//
	//Note: Make sure this algo is safe...
	
	if(!cpList) cpList=cList;

	if(*cpList==0)
	{
		cNameServer[0]=0;
		cpList=NULL;
		return(0);	
	}
	else if((cp=strchr(cpList,'\n')))
	{
		if(strstr(cpList,"MASTER")) 
			retval=1;
		else 
			retval=2;
		*cp=0;
		if((cp2=strchr(cpList,' ')))
			*cp2=0;
		strcpy(cNameServer,cpList);
	}
	
	cpList=cp+1;
	return(retval);
	
}//int FetchNameServer(char *cList, char cNameServer)



void PassDirectHtml(char *file)
{
	FILE *fp;
	char buffer[1024];

	if((fp=fopen(file,"r"))!=NULL)
	{
		while(fgets(buffer,1024,fp)!=NULL)
			printf("%s",buffer);

		fclose(fp);
	}

}//void PassDirectHtml(char *file)


void ParseExtParams(structExtJobParameters *structExtParam, char *cJobData)
{
	char *cp,*cp2;

	if((cp=strstr(cJobData,"Domain=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+7,'\n'))) *cp2=0;
			sprintf(structExtParam->cZone,"%.99s",cp+7);
		if(cp2) *cp2='\n';
		structExtParam->uParamZone=1;
	}
	if((cp=strstr(cJobData,"Zone=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+5,'\n'))) *cp2=0;
			sprintf(structExtParam->cZone,"%.99s",cp+5);
		if(cp2) *cp2='\n';
		structExtParam->uParamZone=1;
	}

	if((cp=strstr(cJobData,"IP=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+3,'\n'))) *cp2=0;
			sprintf(structExtParam->cMainAddress,"%.15s",cp+3);
		if(cp2) *cp2='\n';
		structExtParam->uParamMainAddress=1;
	}
	if((cp=strstr(cJobData,"MainAddress=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+12,'\n'))) *cp2=0;
			sprintf(structExtParam->cMainAddress,"%.15s",cp+12);
		if(cp2) *cp2='\n';
		structExtParam->uParamMainAddress=1;
	}

	if((cp=strstr(cJobData,"Target=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+7,'\n'))) *cp2=0;
			sprintf(structExtParam->cTarget,"%.99s",cp+7);
		if(cp2) *cp2='\n';
		structExtParam->uParamTarget=1;
	}
	if((cp=strstr(cJobData,"ParkedDomains=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+14,'\n'))) *cp2=0;
			sprintf(structExtParam->cParkedDomains,"%.255s",cp+14);
		if(cp2) *cp2='\n';
		if(structExtParam->cParkedDomains[0])
			structExtParam->uParamParkedDomains=1;
	}
	if((cp=strstr(cJobData,"NameServer=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+11,'\n'))) *cp2=0;
			sprintf(structExtParam->cNameServer,"%.99s",cp+11);
		if(cp2) *cp2='\n';
		structExtParam->uParamNameServer=1;
		//Determine structExtParam->uNameServer
	}
	if((cp=strstr(cJobData,"MailServer=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+11,'\n'))) *cp2=0;
			sprintf(structExtParam->cMailServer,"%.99s",cp+11);
		if(cp2) *cp2='\n';
		structExtParam->uParamMailServer=1;
		//Determine structExtParam->uMailServer
	}
	if((cp=strstr(cJobData,"RevDns=")))
	{
		if(*(cp+7)=='y' || *(cp+7)=='Y')
			structExtParam->uRevDns=1;
		structExtParam->uParamRevDns=1;
	}

	if((cp=strstr(cJobData,"MX1=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+4,'\n'))) *cp2=0;
			sprintf(structExtParam->cMX1,"%.99s",cp+4);
		if(cp2) *cp2='\n';
		structExtParam->uParamMX1=1;
	}

	if((cp=strstr(cJobData,"MX2=")))
	{
		cp2=NULL;
		if((cp2=strchr(cp+4,'\n'))) *cp2=0;
			sprintf(structExtParam->cMX2,"%.99s",cp+4);
		if(cp2) *cp2='\n';
		structExtParam->uParamMX1=1;
	}

	//Debug only
	printf("cZone=%s cMainAddress=%s cTarget=%s cNameServer=%s\n cMailServer=%s\ncParkedDomains=%s\nuRevDns=%u\ncMX1=%s cMX2=%s uMailServer=%u\n",
			structExtParam->cZone,
			structExtParam->cMainAddress,
			structExtParam->cTarget,
			structExtParam->cNameServer,
			structExtParam->cMailServer,
			structExtParam->cParkedDomains,
			structExtParam->uRevDns,
			structExtParam->cMX1,
			structExtParam->cMX2,
			structExtParam->uMailServer);

}//void ParseExtParams()


unsigned GetuServer(char *cLabel, char *cTable)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	char query[512];
	unsigned uServer=0;
	
	sprintf(query,"SELECT _rowid FROM %s WHERE cLabel='%s'",cTable,cLabel);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysqlext));
		return(0);
	}
	res=mysql_store_result(&mysql);
        if((field=mysql_fetch_row(res)))
		sscanf(field[0],"%u",&uServer);
	mysql_free_result(res);
	return(uServer);

}//unsigned GetuServer(char *cLabel, char *cTable)


void InitializeParams(structExtJobParameters *structExtParam)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	static unsigned uOnlyOnce=1;
	static unsigned uMailServer=0;
	static unsigned uNameServer=0;
	static char cHostmaster[256];
	static char cMailServer[256];
	static char cNameServer[256];

	if(uOnlyOnce)
	{
		//Load presets
		GetConfiguration("cHostmaster",cHostmaster,0);

		GetConfiguration("cMailServer",cMailServer,0);
		GetConfiguration("cNameServer",cNameServer,0);
		if(cNameServer[0])
			uNameServer=GetuServer(cNameServer,"tNameServer");
		if(cMailServer[0])
			uMailServer=GetuServer(cMailServer,"tMailServer");

		//TODO
		//Allow no mail server...via circuitous route: Specify in tConfiguration 
		//a non existant one. Otherwise use first one found.
		//Of course service param can overwrite this...if job setup works that way.
		if(!uMailServer && !cMailServer[0])
		{

			sprintf(query,"SELECT uMailServer FROM tMailServer LIMIT 1");
 
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				exit(1);
			}
			res=mysql_store_result(&mysql);
		        if((field=mysql_fetch_row(res)))
				sscanf(field[0],"%u",&uMailServer);
			mysql_free_result(res);
		}

		//We always need one, get the first one by uNameServer
		if(!uNameServer)
		{
			sprintf(query,"SELECT uNameServer FROM tNameServer LIMIT 1");
 
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				exit(1);
			}
			res=mysql_store_result(&mysql);
		        if((field=mysql_fetch_row(res)))
				sscanf(field[0],"%u",&uNameServer);
			mysql_free_result(res);
		}

		if(!uNameServer)
		{
			fprintf(stderr,"Undefined name server group. Please configure.\n");
			exit(1);
		}

		uOnlyOnce=0;
	}

	structExtParam->cZone[0]=0;
	structExtParam->cMainAddress[0]=0;
	strcpy(structExtParam->cHostmaster,cHostmaster);
	structExtParam->cTarget[0]=0;
	structExtParam->cParkedDomains[0]=0;
	structExtParam->cNameServer[0]=0;
	structExtParam->cMailServer[0]=0;
	structExtParam->cMX1[0]=0;
	structExtParam->cMX2[0]=0;
	structExtParam->uRevDns=0;

	structExtParam->uExpire=604800;
	structExtParam->uRefresh=28800;
	structExtParam->uTTL=86400;
	structExtParam->uRetry=7200;
	structExtParam->uZoneTTL=86400;

	structExtParam->uNameServer=uNameServer;
	structExtParam->uMailServer=uMailServer;

	//Presence data
	structExtParam->uParamZone=0;
	structExtParam->uParamMainAddress=0;
	structExtParam->uParamTarget=0;
	structExtParam->uParamParkedDomains=0;
	structExtParam->uParamNameServer=0;
	structExtParam->uParamMailServer=0;
	structExtParam->uParamRevDns=0;
	structExtParam->uParamMX1=0;
	structExtParam->uParamMX2=0;

}//void InitializeParams(structExtJobParameters *structExtParam)


int InformExtJob(char *cRemoteMsg,char *cServer,unsigned uJob,unsigned uJobStatus)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	unsigned uJobGroup=0;
	unsigned uInstance=0;
	time_t clock;

	time(&clock);

	sprintf(query,"UPDATE tJob SET cServer='%s',cRemoteMsg='%.32s',uModBy=1,uModDate=%lu,uJobStatus=%u WHERE uJob=%u",cServer,cRemoteMsg,clock,uJobStatus,uJob);

	mysql_query(&mysqlext,query);
	if(mysql_errno(&mysqlext))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysqlext));
		SubmitISPJob("mysqlBind.InformExtJob.Failed",
				mysql_error(&mysqlext),cServer,clock);
		return(1);
	}

	//Do not continue unless closing ext job	
	if(uJobStatus!=mysqlISP_Deployed)
		return(0);
	
	//See if all services of client product instance (now grouped via unique 
	//uJobGroup by mysqlISP SubmitJob routines) are now deployed. If they are 
	//then change mysqlISP.tInstance.uStatus to mysqlISP_Deployed, 
	//				mysqlISP_Canceled or mysqlISP_OnHold
	//
	sprintf(query,"SELECT uJobGroup,uInstance FROM tJob WHERE uJob=%u",uJob);
	mysql_query(&mysqlext,query);
	if(mysql_errno(&mysqlext))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysqlext));
		return(1);
	}
	res=mysql_store_result(&mysqlext);
        if((field=mysql_fetch_row(res)))
	{
		sscanf(field[0],"%u",&uJobGroup);
		sscanf(field[1],"%u",&uInstance);
	}
	mysql_free_result(res);

	if(!uJobGroup || !uInstance)
	{
		fprintf(stderr,"Unexpected missing uJobGroup/uInstance for uJob=%u\n"
						,uJob);
		return(0);
	}

	sprintf(query,"select uJobStatus=%u,(max(uJobStatus)=min(uJobStatus)),cJobName FROM tJob WHERE uJobGroup=%u GROUP BY uJobGroup",mysqlISP_Deployed,uJobGroup);

	mysql_query(&mysqlext,query);
	if(mysql_errno(&mysqlext))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysqlext));
	}
	else
	{
		res=mysql_store_result(&mysqlext);
        	if((field=mysql_fetch_row(res)))
		{
			unsigned uInstanceStatus=mysqlISP_Deployed;

			if(field[0][0]=='1' && field[1][0]=='1')
			{
				if(strstr(field[2],".Cancel"))
					uInstanceStatus=mysqlISP_Canceled;
				else if(strstr(field[2],".Hold"))
					uInstanceStatus=mysqlISP_OnHold;

				sprintf(query,"UPDATE tInstance SET uStatus=%u,uModBy=1,uModDate=%lu WHERE uInstance=%u",uInstanceStatus,clock,uInstance);
				mysql_query(&mysqlext,query);
				if(mysql_errno(&mysqlext))
					fprintf(stderr,"%s\n",mysql_error(&mysqlext));
			}
		}
		mysql_free_result(res);
	}

	return(0);

}//int InformExtJob()


int SubmitISPJob(char *cJobName,char *cJobData,char *cServer,unsigned uJobDate)
{
	time_t clock;

	time(&clock);
	
	sprintf(query,"INSERT INTO tJob SET  cServer='%s', cJobName='%s', cJobData='%.1024s', uJobDate=%u, uOwner=1, uCreatedBy=1, uCreatedDate=%lu, uJobStatus=%u, cLabel='mysqlBind.SubmitISPJob'",
			cServer
			,cJobName
			,TextAreaSave(cJobData)
			,uJobDate
			,clock
			,mysqlISP_Waiting);
	mysql_query(&mysqlext,query);
	if(mysql_errno(&mysqlext))
	{
                fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}

	return(0);

}//int SubmitISPJob()


void ExtConnectDb(unsigned uHtml)
{
	char cDbIp[256]={""};
	char *cEffectiveDbIp=NULL;
	char cDbName[256]={"mysqlisp"};
	char cDbPwd[256]={"wsxedc"};
	char cDbLogin[256]={"mysqlisp"};
	static unsigned uOnlyOnce=0;

	if(uOnlyOnce) return;
	uOnlyOnce=1;

	GetConfiguration("cExtJobQueueDbIp",cDbIp,0);
	GetConfiguration("cExtJobQueueDbName",cDbName,0);
	GetConfiguration("cExtJobQueueDbPwd",cDbPwd,0);
	GetConfiguration("cExtJobQueueDbLogin",cDbLogin,0);

	//Debug only	
	//printf("%s %s %s %s\n",cDbIp,cDbName,cDbPwd,cDbLogin);

	if(cDbIp[0]) cEffectiveDbIp=cDbIp;

        mysql_init(&mysqlext);
        if (!mysql_real_connect(&mysqlext,cEffectiveDbIp,
				cDbLogin,cDbPwd,cDbName,0,NULL,0))
        {
		sprintf(query,"ExtConnectDb failed for %s.%s",cDbIp,cDbName);
		if(uHtml)
                	mysqlBind(query);
		else
			fprintf(stderr,"%s\n",query);
		exit(1);
        }

}//end of ExtConnectDb()


void ProcessExtJobQueue(char *cServer)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	MYSQL_RES *res2;
	MYSQL_ROW field2;

	structExtJobParameters structExtParam;

	unsigned uJob=0;
	unsigned uJobClient=0;
	unsigned uZone=0;

	time_t clock;
	char query[10240];

		
	ConnectDb();//Must be first
	ExtConnectDb(0);

	time(&clock);

	sprintf(query,"SELECT cJobName,cJobData,uJob,uJobClient FROM tJob WHERE (cServer='Any' OR cServer='%s') AND uJobStatus=%u AND uJobDate<=%lu AND cJobName LIKE 'mysqlBind.%%'",cServer,mysqlISP_Waiting,clock);

	//Debug only	
	//printf("%s\n",query);


	mysql_query(&mysqlext,query);
        if(mysql_errno(&mysqlext))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysqlext));
		return;
	}

	res=mysql_store_result(&mysqlext);
        while((field=mysql_fetch_row(res)))
	{
		InitializeParams(&structExtParam);

		sscanf(field[2],"%u",&uJob);
		sscanf(field[3],"%u",&uJobClient);

		if(!strcmp("mysqlBind.Web.New",field[0]))
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select query Web.New failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
        			if((field2=mysql_fetch_row(res2)))
				{
					//Modify
					sscanf(field2[0],"%u",&uZone);

					//Already exists change IP
					//and other parameters
					if(!WebMod(&structExtParam,
							uZone,uJob,cServer))
					InformExtJob("WebMod() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
					else
					InformExtJob("WebMod() Error",
						cServer,uJob,mysqlISP_Waiting);
				}
				else
				{
					unsigned uRetVal;
					//New
					uRetVal=WebNew(&structExtParam,uJob,cServer);
					switch(uRetVal)
					{
						case 0:
					InformExtJob("WebNew() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
						break;
						
						case 1:
					InformExtJob("WebNew() Error",
						cServer,uJob,mysqlISP_Waiting);
						break;
						
						case 2:
					InformExtJob("WebNew() Waiting for IP",
						cServer,uJob,mysqlISP_Waiting);
						break;
					}
				}
				mysql_free_result(res2);
			}
		}//Web.New


		else if(	!strcmp("mysqlBind.Web.Mod",field[0]) ||
				!strcmp("mysqlBind.WebZone.Mod",field[0]) ||
				!strcmp("mysqlBind.Zone.Mod",field[0]) )
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select query Mod failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
        			if((field2=mysql_fetch_row(res2)))
				{
					//Modify
					sscanf(field2[0],"%u",&uZone);

					if(!ModZone(&structExtParam,
							uZone,uJob,cServer))
					InformExtJob("ModZone() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
					else
					InformExtJob("ModZone() Error",
						cServer,uJob,mysqlISP_Waiting);
				}
				else
				{
					InformExtJob("Zone does not exist",
						cServer,uJob,mysqlISP_Waiting);
				}
				mysql_free_result(res2);
			}

		}//Web/Zone/WebZone.Mod


		else if(	!strcmp("mysqlBind.Web.Cancel",field[0]) ||
				!strcmp("mysqlBind.WebZone.Cancel",field[0]) ||
				!strcmp("mysqlBind.Zone.Cancel",field[0]) )
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select query Cancel failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
        			if((field2=mysql_fetch_row(res2)))
				{
					//Cancel
					sscanf(field2[0],"%u",&uZone);

					if(!CancelZone(&structExtParam,
							uZone,uJob,cServer))
					InformExtJob("CancelZone() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
					else
					InformExtJob("CancelZone() Error",
						cServer,uJob,mysqlISP_Waiting);
				}
				else
				{
					InformExtJob("No such zone error",
							cServer,uJob,mysqlISP_Waiting);
				}
				mysql_free_result(res2);
			}

		}//Web/Zone/WebZone.Cancel


		//OnHold: Do nothing
		else if(	!strcmp("mysqlBind.Web.OnHold",field[0]) ||
				!strcmp("mysqlBind.WebZone.OnHold",field[0]) ||
				!strcmp("mysqlBind.Zone.OnHold",field[0]) )
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select query OnHold failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
        			if(mysql_num_rows(res2))
				{
					//OnHold: Do nothing
					InformExtJob("OnHold NOP",
						cServer,uJob,mysqlISP_Deployed);
				}
				else
				{
					InformExtJob("No such cZone",
							cServer,uJob,mysqlISP_Waiting);
				}
				mysql_free_result(res2);
			}

		}//Web/Zone/WebZone.OnHold


		else if(!strcmp("mysqlBind.Zone.New",field[0]))
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select Zone.New failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
				if(mysql_num_rows(res2))
				{
					InformExtJob("Zone already exists!",
						cServer,uJob,mysqlISP_Waiting);
				}
				else
				{
					unsigned uRetVal;
					uRetVal=NewSimpleZone(&structExtParam,uJob,cServer);
					switch(uRetVal)
					{
						case 0:
					InformExtJob("NewSimpleZone() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
						break;
						
						default:
					InformExtJob("NewSimpleZone() Error",
						cServer,uJob,mysqlISP_Waiting);
						break;
						
					}
				}
				mysql_free_result(res2);
			}
		}//Zone.New


		else if(!strcmp("mysqlBind.WebZone.New",field[0]))
		{	
			printf("\n%s(%s):\n",field[0],field[2]);
			ParseExtParams(&structExtParam,field[1]);
sprintf(query,"SELECT uZone FROM tZone WHERE cZone='%s'",structExtParam.cZone);
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
        		{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				InformExtJob("Select WebZone.New failed",
						cServer,uJob,mysqlISP_Waiting);
			}
			else
			{
        			res2=mysql_store_result(&mysql);
				if(mysql_num_rows(res2))
				{
					InformExtJob("Zone already exists!",
						cServer,uJob,mysqlISP_Waiting);
				}
				else
				{
					unsigned uRetVal;
					uRetVal=NewSimpleWebZone(&structExtParam,uJob,cServer);
					switch(uRetVal)
					{
						case 0:
					InformExtJob("NewSimpleWebZone() Ok",
						cServer,uJob,mysqlISP_RemotelyQueued);
						break;
						
						default:
					InformExtJob("NewSimpleWebZone() Error",
						cServer,uJob,mysqlISP_Waiting);
						break;
						
					}
				}
				mysql_free_result(res2);
			}
		}//WebZone.New


		else if(1)
		{
			fprintf(stderr,"Unknown job:%s\n",field[0]);
		}
	}
	mysql_free_result(res);

}//void ProcessExtJobQueue(char *cServer)


unsigned WebMod(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uExtJob, char *cServer)
{
	time_t clock;

	//Very limited changes allowed so far...
	time(&clock);
sprintf(query,"UPDATE tZone SET uSerial=uSerial+1,uMailServers=%u,cMainAddress='%s',uModBy=1, uModDate=%lu WHERE uZone=%u"
			,structExtParam->uMailServer
			,structExtParam->cMainAddress
			,clock
			,uZone);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	if(SubmitExtJob("ExtModify",structExtParam->uNameServer,
					structExtParam->cZone,0,
					clock,uExtJob))
		return(1);

	return(0);

}//unsigned WebMod()


unsigned ModZone(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uExtJob, char *cServer)
{
        MYSQL_RES *res;
        MYSQL_ROW field;
	time_t clock;

	time(&clock);

	//Complicated NS operations as additional parameters
	if(!structExtParam->uMailServer)
	{
		//uRRType=3 = MX record TODO
		if(structExtParam->cMX1[0])
		{
			sprintf(query,"SELECT uResource FROM tResource WHERE uRRType=3 AND uZone=%u AND cParam1='1'",uZone);
        		mysql_query(&mysql,query);
        		if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		        res=mysql_store_result(&mysql);
			if(!mysql_num_rows(res))
			{
				sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='1',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='ModZone()'",
					uZone,
					structExtParam->cMX1,
					structExtParam->cZone,
					clock);
        			mysql_query(&mysql,query);
	        		if(mysql_errno(&mysql))
				{
					fprintf(stderr,"%s\n",mysql_error(&mysql));
					return(1);
				}
			}
			else
			{
        			if((field=mysql_fetch_row(res)))
				{
					sprintf(query,"UPDATE tResource SET cParam2='%s.',uModBy=1,uModDate=%lu WHERE uResource=%s",
					structExtParam->cMX1,
					clock,
					field[0]);

	        			mysql_query(&mysql,query);
		        		if(mysql_errno(&mysql))
					{
						fprintf(stderr,"%s\n",mysql_error(&mysql));
						return(1);
					}
				}
			}
        		mysql_free_result(res);
		}//End of MX1 case

		if(structExtParam->cMX2[0])
		{
			sprintf(query,"SELECT uResource FROM tResource WHERE uRRType=3 AND uZone=%u AND cParam1='2'",uZone);
        		mysql_query(&mysql,query);
        		if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		        res=mysql_store_result(&mysql);
			if(!mysql_num_rows(res))
			{
				sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='2',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='ModZone()'",
					uZone,
					structExtParam->cMX2,
					structExtParam->cZone,
					clock);
        			mysql_query(&mysql,query);
	        		if(mysql_errno(&mysql))
				{
					fprintf(stderr,"%s\n",mysql_error(&mysql));
					return(1);
				}
			}
			else
			{
        			if((field=mysql_fetch_row(res)))
				{
					sprintf(query,"UPDATE tResource SET cParam2='%s.',uModBy=1,uModDate=%lu WHERE uResource=%s",
					structExtParam->cMX2,
					clock,
					field[0]);

	        			mysql_query(&mysql,query);
		        		if(mysql_errno(&mysql))
					{
						fprintf(stderr,"%s\n",mysql_error(&mysql));
						return(1);
					}
				}
			}
        		mysql_free_result(res);
		}//End of MX2 case

	}//End of MX business

	//Very limited changes allowed so far...
sprintf(query,"UPDATE tZone SET uSerial=uSerial+1,uMailServers=%u,cMainAddress='%s',uModBy=1,uModDate=%lu WHERE uZone=%u"
			,structExtParam->uMailServer
			,structExtParam->cMainAddress
			,clock
			,uZone);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	if(SubmitExtJob("ExtModify",structExtParam->uNameServer,
					structExtParam->cZone,0,
					clock,uExtJob))
		return(1);

	return(0);

}//unsigned ModZone()


unsigned CancelZone(structExtJobParameters *structExtParam,
				unsigned uZone,unsigned uExtJob, char *cServer)
{
	time_t clock;

	sprintf(query,"DELETE FROM tZone WHERE uZone=%u",uZone);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
        {
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}

	if(mysql_affected_rows(&mysql)>0)
	{
		time(&clock);
		sprintf(query,
		"DELETE FROM tResource WHERE uZone=%u",uZone);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) 
			fprintf(stderr,"%s\n",mysql_error(&mysql));

		if(SubmitExtJob("ExtDelete",structExtParam->uNameServer,
					structExtParam->cZone,0,
					clock,uExtJob))
			return(1);

		return(0);
	}

	return(1);

}//unsigned CancelZone()



void ApacheConnectDb(MYSQL *mysqlext)
{
	char cDbIp[256]={""};
	char *cEffectiveDbIp=NULL;
	char cDbName[256]={"mysqlapache"};
	char cDbPwd[256]={"wsxedc"};
	char cDbLogin[256]={"mysqlapache"};

	GetConfiguration("cExtApacheDbIp",cDbIp,0);
	GetConfiguration("cExtApacheDbName",cDbName,0);
	GetConfiguration("cExtApacheDbPwd",cDbPwd,0);
	GetConfiguration("cExtApacheDbLogin",cDbLogin,0);

	//Debug only	
	//printf("%s %s %s %s\n",cDbIp,cDbName,cDbPwd,cDbLogin);

	if(cDbIp[0]) cEffectiveDbIp=cDbIp;

        mysql_init(mysqlext);
        if (!mysql_real_connect(mysqlext,cEffectiveDbIp,
				cDbLogin,cDbPwd,cDbName,0,NULL,0))
        {
		fprintf(stderr,"ApacheConnectDb failed for %s.%s",cDbIp,cDbName);
		return;
        }

}//end of ApacheConnectDb()


int GetApacheIPNumber(MYSQL *mysql,char *cDomain,char *cMainAddress)
{
        MYSQL_RES *res;
        MYSQL_ROW field;
	unsigned uRetVal=1;

        char query[512];

        sprintf(query,"SELECT cIP FROM tVirtualHost WHERE cDomain='%s'",cDomain);
        mysql_query(mysql,query);
        if(mysql_errno(mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(mysql));
		return(1);
	}
        res=mysql_store_result(mysql);
        if((field=mysql_fetch_row(res)))
	{
                strcpy(cMainAddress,field[0]);
		uRetVal=0;
	}
        mysql_free_result(res);
	
	return(uRetVal);

}//int GetApacheIPNumber(MYSQL *mysql,char *cDomain,char *cMainAddress)


unsigned WebNew(structExtJobParameters *structExtParam,unsigned uJob, char *cServer)
{
	char cSerial[32]={""};
	unsigned uSerial=0;
	unsigned uZone=0;
	time_t clock;
	MYSQL mysqlapache;

	if(!strcmp(structExtParam->cZone+strlen(structExtParam->cZone)-5,".arpa"))
	{
		fprintf(stderr,"Can't add .arpa zones via mysqlISP\n");
		return(1);
	}

	SerialNum(cSerial);
	sscanf(cSerial,"%u",&uSerial);
	time(&clock);

	//Name based or IP based same: Get IP from mysqlApache
	ApacheConnectDb(&mysqlapache);
	if(GetApacheIPNumber(&mysqlapache,structExtParam->cZone,
					structExtParam->cMainAddress))
			return(2);
	
	if(!structExtParam->cHostmaster[0])
		//Note non @ format
		sprintf(structExtParam->cHostmaster,"dns.%.94s",structExtParam->cZone);

sprintf(query,"INSERT INTO tZone SET  cZone='%s', uNameServer=%u, cHostmaster='%s', uSerial=%u, uExpire=%u, uRefresh=%u, uTTL=%u, uRetry=%u, uZoneTTL=%u, uMailServers=%u, cMainAddress='%s', uOwner=1, uCreatedBy=1, uCreatedDate=%lu"
			,structExtParam->cZone
			,structExtParam->uNameServer
			,structExtParam->cHostmaster
			,uSerial
			,structExtParam->uExpire
			,structExtParam->uRefresh
			,structExtParam->uTTL
			,structExtParam->uRetry
			,structExtParam->uZoneTTL
			,structExtParam->uMailServer
			,structExtParam->cMainAddress
			,clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}

	uZone=mysql_insert_id(&mysql);

	if(structExtParam->cMainAddress[0] && structExtParam->uRevDns
			&& strcmp(structExtParam->cMainAddress,"0.0.0.0"))
	{
		if(PopulateArpaZone(structExtParam->cZone,
					structExtParam->cMainAddress,0,uZone))
			return(1);
	}

	//Add CNAME uRRType=5 TODO
	sprintf(query,"INSERT INTO tResource SET uRRType=5,uZone=%u,cParam1='%s.',cName='www',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='WebNew()'",
					uZone,
					structExtParam->cZone,
					clock);
       	mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}


	if(SubmitExtJob("ExtNew",structExtParam->uNameServer,
					structExtParam->cZone,0,clock,uJob))
		return(1);

	return(0);

}//unsigned WebNew()


unsigned NewSimpleZone(structExtJobParameters *structExtParam,unsigned uJob, char *cServer)
{
	char cSerial[32]={""};
	unsigned uSerial=0;
	unsigned uZone=0;
	time_t clock;

	if(!strcmp(structExtParam->cZone+strlen(structExtParam->cZone)-5,".arpa"))
	{
		fprintf(stderr,"Can't add .arpa zones via mysqlISP\n");
		return(1);
	}

	SerialNum(cSerial);
	sscanf(cSerial,"%u",&uSerial);
	time(&clock);

	if(!structExtParam->cHostmaster[0])
		//Note non @ format
		sprintf(structExtParam->cHostmaster,"dns.%.94s",structExtParam->cZone);

sprintf(query,"INSERT INTO tZone SET  cZone='%s', uNameServer=%u, cHostmaster='%s', uSerial=%u, uExpire=%u, uRefresh=%u, uTTL=%u, uRetry=%u, uZoneTTL=%u, uMailServers=%u, cMainAddress='%s', uOwner=1, uCreatedBy=1, uCreatedDate=%lu"
			,structExtParam->cZone
			,structExtParam->uNameServer
			,structExtParam->cHostmaster
			,uSerial
			,structExtParam->uExpire
			,structExtParam->uRefresh
			,structExtParam->uTTL
			,structExtParam->uRetry
			,structExtParam->uZoneTTL
			,structExtParam->uMailServer
			,structExtParam->cMainAddress
			,clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	uZone=mysql_insert_id(&mysql);

	if(structExtParam->cMainAddress[0] && structExtParam->uRevDns
			&& strcmp(structExtParam->cMainAddress,"0.0.0.0"))
	{
		if(PopulateArpaZone(structExtParam->cZone,
					structExtParam->cMainAddress,0,uZone))
			return(1);
	}

	if(!structExtParam->uMailServer)
	{
		//uRRType=3 = MX record TODO
		if(structExtParam->cMX1[0])
		{
			sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='1',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='NewSimpleZone()'",
						uZone,
						structExtParam->cMX1,
						structExtParam->cZone,
						clock);
	        	mysql_query(&mysql,query);
		        if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		}//End of MX1 case

		if(structExtParam->cMX2[0])
		{
			sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='2',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='NewSimpleZone()'",
						uZone,
						structExtParam->cMX2,
						structExtParam->cZone,
						clock);
	        	mysql_query(&mysql,query);
		        if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		}//End of MX2 case
	}//End of MX1/2 and no uMailServer

	if(SubmitExtJob("ExtNew",structExtParam->uNameServer,
					structExtParam->cZone,0,clock,uJob))
		return(1);

	return(0);

}//unsigned NewSimpleZone()


unsigned NewSimpleWebZone(structExtJobParameters *structExtParam,unsigned uJob, char *cServer)
{
	char cSerial[32]={""};
	unsigned uSerial=0;
	unsigned uZone=0;
	time_t clock;

	if(!strcmp(structExtParam->cZone+strlen(structExtParam->cZone)-5,".arpa"))
	{
		fprintf(stderr,"Can't add .arpa zones via mysqlISP\n");
		return(1);
	}

	SerialNum(cSerial);
	sscanf(cSerial,"%u",&uSerial);
	time(&clock);

	if(!structExtParam->cHostmaster[0])
		//Note non @ format
		sprintf(structExtParam->cHostmaster,"dns.%.94s",structExtParam->cZone);

sprintf(query,"INSERT INTO tZone SET  cZone='%s', uNameServer=%u, cHostmaster='%s', uSerial=%u, uExpire=%u, uRefresh=%u, uTTL=%u, uRetry=%u, uZoneTTL=%u, uMailServers=%u, cMainAddress='%s', uOwner=1, uCreatedBy=1, uCreatedDate=%lu"
			,structExtParam->cZone
			,structExtParam->uNameServer
			,structExtParam->cHostmaster
			,uSerial
			,structExtParam->uExpire
			,structExtParam->uRefresh
			,structExtParam->uTTL
			,structExtParam->uRetry
			,structExtParam->uZoneTTL
			,structExtParam->uMailServer
			,structExtParam->cMainAddress
			,clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	uZone=mysql_insert_id(&mysql);


	if(structExtParam->cMainAddress[0] && structExtParam->uRevDns
			&& strcmp(structExtParam->cMainAddress,"0.0.0.0"))
	{
		if(PopulateArpaZone(structExtParam->cZone,
					structExtParam->cMainAddress,0,uZone))
			return(1);
	}


	if(!structExtParam->uMailServer)
	{
		//uRRType=3 = MX record TODO
		if(structExtParam->cMX1[0])
		{
			sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='1',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='NewSimpleWebZone()'",
						uZone,
						structExtParam->cMX1,
						structExtParam->cZone,
						clock);
	        	mysql_query(&mysql,query);
		        if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		}//End of MX1 case

		if(structExtParam->cMX2[0])
		{
			sprintf(query,"INSERT INTO tResource SET uRRType=3,uZone=%u,cParam2='%s.',cParam1='2',cName='%s.',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='NewSimpleWebZone()'",
						uZone,
						structExtParam->cMX2,
						structExtParam->cZone,
						clock);
	        	mysql_query(&mysql,query);
		        if(mysql_errno(&mysql))
			{
				fprintf(stderr,"%s\n",mysql_error(&mysql));
				return(1);
			}
		}//End of MX2 case
	}//End of MX1/2 and no uMailServer


	//Add CNAME uRRType=5 TODO
	sprintf(query,"INSERT INTO tResource SET uRRType=5,uZone=%u,cParam1='%s.',cName='www',uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cComment='NewSimpleWebZone()'",
					uZone,
					structExtParam->cZone,
					clock);
       	mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}

	if(SubmitExtJob("ExtNew",structExtParam->uNameServer,
					structExtParam->cZone,0,clock,uJob))
		return(1);

	return(0);

}//unsigned NewSimpleWebZone()


void GetConfiguration(const char *cName, char *cValue, unsigned uHtml)
{
        MYSQL_RES *res;
        MYSQL_ROW field;

        char query[512];

        sprintf(query,"SELECT cValue FROM tConfiguration WHERE cLabel='%s'",cName);
        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
	{
		if(uHtml)
		{
        	        tConfiguration(mysql_error(&mysql));
		}
		else
		{
			fprintf(stderr,"%s\n",mysql_error(&mysql));
			exit(1);
		}
	}
        res=mysql_store_result(&mysql);
        if((field=mysql_fetch_row(res)))
                strcpy(cValue,field[0]);
        mysql_free_result(res);

}//void GetConfiguration(char *cName, char *cValue)


int SubmitExtJob(char *cCommand, unsigned uNameServerArg, char *cZoneArg,
			unsigned uPriorityArg, unsigned uTimeArg, unsigned uExtJob)
{
	MYSQL_RES *res2;
	MYSQL_ROW field;
	char cTargetServer[256];
	static unsigned uMasterJob=0;

	//Submit one job per EACH NS in the list, group with
	//uMasterJob
	sprintf(query,"SELECT cList FROM tNameServer WHERE uNameServer=%u",
			uNameServerArg);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	res2=mysql_store_result(&mysql);
	
	if((field=mysql_fetch_row(res2)))
	{
		register int i,j=0;

		for(i=0;i<strlen(field[0]);i++)
		{
			if(field[0][i]!='\n' && field[0][i])
			{
				cTargetServer[j++]=field[0][i];
			}
			else
			{
				cTargetServer[j]=0;
				j=0;
				if(SubmitSingleExtJob(cCommand,cZoneArg,uNameServerArg,
						cTargetServer,uPriorityArg,uTimeArg,
						&uMasterJob,uExtJob))
					return(1);
			}
		}
	}
	mysql_free_result(res2);

	return(0);

}//int SubmitExtJob()


int SubmitSingleExtJob(char *cCommand,char *cZoneArg, unsigned uNameServerArg,
		char *cTargetServer, unsigned uPriorityArg, unsigned uTimeArg
	       			,unsigned *uMasterJob,unsigned uExtJob)
{
	MYSQL_RES *res;

sprintf(query,"SELECT uJob FROM tJob WHERE cJob='%s' AND cZone='%s' AND uNameServer=%u AND cTargetServer='%s'",cCommand,cZoneArg,uNameServerArg,cTargetServer);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		return(1);
	}
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)==0)
	{
		time_t clock;
		char cJobData[32];
		unsigned uJob=0;

		time(&clock);

		sprintf(cJobData,"uJob=%u",uExtJob);
sprintf(query,"INSERT INTO tJob SET cJob='%s', cZone='%s', uNameServer=%u, cTargetServer='%s', uPriority=%u, uTime=%u, cJobData='%s', uOwner=1, uCreatedBy=1, uCreatedDate=%lu"
			,cCommand
			,cZoneArg
			,uNameServerArg
			,cTargetServer
			,uPriorityArg
			,uTimeArg
			,cJobData
			,clock);

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			fprintf(stderr,"%s\n",mysql_error(&mysql));
			mysql_free_result(res);
			return(1);
		}

		if(*uMasterJob == 0)
		{
			uJob=*uMasterJob=mysql_insert_id(&mysql);
			if(!strstr(cTargetServer,"MASTER"))
				fprintf(stderr,"MASTER must be first in cList\n");
		}
		else
		{
			uJob=mysql_insert_id(&mysql);
		}
	
		sprintf(query,"UPDATE tJob SET uMasterJob=%u WHERE uJob=%u",*uMasterJob,uJob);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			fprintf(stderr,"%s\n",mysql_error(&mysql));
			mysql_free_result(res);
			return(1);
		}
		if(mysql_affected_rows(&mysql)==0)
			//debug only
			printf("uMasterJob %u",*uMasterJob);
	}
	mysql_free_result(res);

	return(0);

}//int SubmitSingleExtJob()

